#lang racket/base

(define CL_SUCCESS 0)
(define CL_DEVICE_NOT_FOUND -1)
(define CL_DEVICE_NOT_AVAILABLE -2)
(define CL_COMPILER_NOT_AVAILABLE -3)
(define CL_MEM_OBJECT_ALLOCATION_FAILURE -4)
(define CL_OUT_OF_RESOURCES -5)
(define CL_OUT_OF_HOST_MEMORY -6)
(define CL_PROFILING_INFO_NOT_AVAILABLE -7)
(define CL_MEM_COPY_OVERLAP -8)
(define CL_IMAGE_FORMAT_MISMATCH -9)
(define CL_IMAGE_FORMAT_NOT_SUPPORTED -10)
(define CL_BUILD_PROGRAM_FAILURE -11)
(define CL_MAP_FAILURE -12)
(define CL_MISALIGNED_SUB_BUFFER_OFFSET -13)
(define CL_EXEC_STATUS_ERROR_FOR_EVENTS_IN_WAIT_LIST -14)
(define CL_COMPILE_PROGRAM_FAILURE -15)
(define CL_LINKER_NOT_AVAILABLE -16)
(define CL_LINK_PROGRAM_FAILURE -17)
(define CL_DEVICE_PARTITION_FAILED -18)
(define CL_KERNEL_ARG_INFO_NOT_AVAILABLE -19)
(define CL_INVALID_VALUE -30)
(define CL_INVALID_DEVICE_TYPE -31)
(define CL_INVALID_PLATFORM -32)
(define CL_INVALID_DEVICE -33)
(define CL_INVALID_CONTEXT -34)
(define CL_INVALID_QUEUE_PROPERTIES -35)
(define CL_INVALID_COMMAND_QUEUE -36)
(define CL_INVALID_HOST_PTR -37)
(define CL_INVALID_MEM_OBJECT -38)
(define CL_INVALID_IMAGE_FORMAT_DESCRIPTOR -39)
(define CL_INVALID_IMAGE_SIZE -40)
(define CL_INVALID_SAMPLER -41)
(define CL_INVALID_BINARY -42)
(define CL_INVALID_BUILD_OPTIONS -43)
(define CL_INVALID_PROGRAM -44)
(define CL_INVALID_PROGRAM_EXECUTABLE -45)
(define CL_INVALID_KERNEL_NAME -46)
(define CL_INVALID_KERNEL_DEFINITION -47)
(define CL_INVALID_KERNEL -48)
(define CL_INVALID_ARG_INDEX -49)
(define CL_INVALID_ARG_VALUE -50)
(define CL_INVALID_ARG_SIZE -51)
(define CL_INVALID_KERNEL_ARGS -52)
(define CL_INVALID_WORK_DIMENSION -53)
(define CL_INVALID_WORK_GROUP_SIZE -54)
(define CL_INVALID_WORK_ITEM_SIZE -55)
(define CL_INVALID_GLOBAL_OFFSET -56)
(define CL_INVALID_EVENT_WAIT_LIST -57)
(define CL_INVALID_EVENT -58)
(define CL_INVALID_OPERATION -59)
(define CL_INVALID_GL_OBJECT -60)
(define CL_INVALID_BUFFER_SIZE -61)
(define CL_INVALID_MIP_LEVEL -62)
(define CL_INVALID_GLOBAL_WORK_SIZE -63)
(define CL_INVALID_PROPERTY -64)
(define CL_INVALID_IMAGE_DESCRIPTOR -65)
(define CL_INVALID_COMPILER_OPTIONS -66)
(define CL_INVALID_LINKER_OPTIONS -67)
(define CL_INVALID_DEVICE_PARTITION_COUNT -68)
(define CL_VERSION_1_0 1)
(define CL_VERSION_1_1 1)
(define CL_VERSION_1_2 1)
(define CL_FALSE 0)
(define CL_TRUE 1)
(define CL_BLOCKING 1)
(define CL_NON_BLOCKING 0)
(define CL_PLATFORM_PROFILE 2304)
(define CL_PLATFORM_VERSION 2305)
(define CL_PLATFORM_NAME 2306)
(define CL_PLATFORM_VENDOR 2307)
(define CL_PLATFORM_EXTENSIONS 2308)
(define CL_DEVICE_TYPE_DEFAULT 1)
(define CL_DEVICE_TYPE_CPU 2)
(define CL_DEVICE_TYPE_GPU 4)
(define CL_DEVICE_TYPE_ACCELERATOR 8)
(define CL_DEVICE_TYPE_CUSTOM 16)
(define CL_DEVICE_TYPE_ALL -1)
(define CL_DEVICE_TYPE 4096)
(define CL_DEVICE_VENDOR_ID 4097)
(define CL_DEVICE_MAX_COMPUTE_UNITS 4098)
(define CL_DEVICE_MAX_WORK_ITEM_DIMENSIONS 4099)
(define CL_DEVICE_MAX_WORK_GROUP_SIZE 4100)
(define CL_DEVICE_MAX_WORK_ITEM_SIZES 4101)
(define CL_DEVICE_PREFERRED_VECTOR_WIDTH_CHAR 4102)
(define CL_DEVICE_PREFERRED_VECTOR_WIDTH_SHORT 4103)
(define CL_DEVICE_PREFERRED_VECTOR_WIDTH_INT 4104)
(define CL_DEVICE_PREFERRED_VECTOR_WIDTH_LONG 4105)
(define CL_DEVICE_PREFERRED_VECTOR_WIDTH_FLOAT 4106)
(define CL_DEVICE_PREFERRED_VECTOR_WIDTH_DOUBLE 4107)
(define CL_DEVICE_MAX_CLOCK_FREQUENCY 4108)
(define CL_DEVICE_ADDRESS_BITS 4109)
(define CL_DEVICE_MAX_READ_IMAGE_ARGS 4110)
(define CL_DEVICE_MAX_WRITE_IMAGE_ARGS 4111)
(define CL_DEVICE_MAX_MEM_ALLOC_SIZE 4112)
(define CL_DEVICE_IMAGE2D_MAX_WIDTH 4113)
(define CL_DEVICE_IMAGE2D_MAX_HEIGHT 4114)
(define CL_DEVICE_IMAGE3D_MAX_WIDTH 4115)
(define CL_DEVICE_IMAGE3D_MAX_HEIGHT 4116)
(define CL_DEVICE_IMAGE3D_MAX_DEPTH 4117)
(define CL_DEVICE_IMAGE_SUPPORT 4118)
(define CL_DEVICE_MAX_PARAMETER_SIZE 4119)
(define CL_DEVICE_MAX_SAMPLERS 4120)
(define CL_DEVICE_MEM_BASE_ADDR_ALIGN 4121)
(define CL_DEVICE_MIN_DATA_TYPE_ALIGN_SIZE 4122)
(define CL_DEVICE_SINGLE_FP_CONFIG 4123)
(define CL_DEVICE_GLOBAL_MEM_CACHE_TYPE 4124)
(define CL_DEVICE_GLOBAL_MEM_CACHELINE_SIZE 4125)
(define CL_DEVICE_GLOBAL_MEM_CACHE_SIZE 4126)
(define CL_DEVICE_GLOBAL_MEM_SIZE 4127)
(define CL_DEVICE_MAX_CONSTANT_BUFFER_SIZE 4128)
(define CL_DEVICE_MAX_CONSTANT_ARGS 4129)
(define CL_DEVICE_LOCAL_MEM_TYPE 4130)
(define CL_DEVICE_LOCAL_MEM_SIZE 4131)
(define CL_DEVICE_ERROR_CORRECTION_SUPPORT 4132)
(define CL_DEVICE_PROFILING_TIMER_RESOLUTION 4133)
(define CL_DEVICE_ENDIAN_LITTLE 4134)
(define CL_DEVICE_AVAILABLE 4135)
(define CL_DEVICE_COMPILER_AVAILABLE 4136)
(define CL_DEVICE_EXECUTION_CAPABILITIES 4137)
(define CL_DEVICE_QUEUE_PROPERTIES 4138)
(define CL_DEVICE_NAME 4139)
(define CL_DEVICE_VENDOR 4140)
(define CL_DRIVER_VERSION 4141)
(define CL_DEVICE_PROFILE 4142)
(define CL_DEVICE_VERSION 4143)
(define CL_DEVICE_EXTENSIONS 4144)
(define CL_DEVICE_PLATFORM 4145)
(define CL_DEVICE_DOUBLE_FP_CONFIG 4146)
(define CL_DEVICE_PREFERRED_VECTOR_WIDTH_HALF 4148)
(define CL_DEVICE_HOST_UNIFIED_MEMORY 4149)
(define CL_DEVICE_NATIVE_VECTOR_WIDTH_CHAR 4150)
(define CL_DEVICE_NATIVE_VECTOR_WIDTH_SHORT 4151)
(define CL_DEVICE_NATIVE_VECTOR_WIDTH_INT 4152)
(define CL_DEVICE_NATIVE_VECTOR_WIDTH_LONG 4153)
(define CL_DEVICE_NATIVE_VECTOR_WIDTH_FLOAT 4154)
(define CL_DEVICE_NATIVE_VECTOR_WIDTH_DOUBLE 4155)
(define CL_DEVICE_NATIVE_VECTOR_WIDTH_HALF 4156)
(define CL_DEVICE_OPENCL_C_VERSION 4157)
(define CL_DEVICE_LINKER_AVAILABLE 4158)
(define CL_DEVICE_BUILT_IN_KERNELS 4159)
(define CL_DEVICE_IMAGE_MAX_BUFFER_SIZE 4160)
(define CL_DEVICE_IMAGE_MAX_ARRAY_SIZE 4161)
(define CL_DEVICE_PARENT_DEVICE 4162)
(define CL_DEVICE_PARTITION_MAX_SUB_DEVICES 4163)
(define CL_DEVICE_PARTITION_PROPERTIES 4164)
(define CL_DEVICE_PARTITION_AFFINITY_DOMAIN 4165)
(define CL_DEVICE_PARTITION_TYPE 4166)
(define CL_DEVICE_REFERENCE_COUNT 4167)
(define CL_DEVICE_PREFERRED_INTEROP_USER_SYNC 4168)
(define CL_DEVICE_PRINTF_BUFFER_SIZE 4169)
(define CL_DEVICE_IMAGE_PITCH_ALIGNMENT 4170)
(define CL_DEVICE_IMAGE_BASE_ADDRESS_ALIGNMENT 4171)
(define CL_FP_DENORM 1)
(define CL_FP_INF_NAN 2)
(define CL_FP_ROUND_TO_NEAREST 4)
(define CL_FP_ROUND_TO_ZERO 8)
(define CL_FP_ROUND_TO_INF 16)
(define CL_FP_FMA 32)
(define CL_FP_SOFT_FLOAT 64)
(define CL_FP_CORRECTLY_ROUNDED_DIVIDE_SQRT 128)
(define CL_NONE 0)
(define CL_READ_ONLY_CACHE 1)
(define CL_READ_WRITE_CACHE 2)
(define CL_LOCAL 1)
(define CL_GLOBAL 2)
(define CL_EXEC_KERNEL 1)
(define CL_EXEC_NATIVE_KERNEL 2)
(define CL_QUEUE_OUT_OF_ORDER_EXEC_MODE_ENABLE 1)
(define CL_QUEUE_PROFILING_ENABLE 2)
(define CL_CONTEXT_REFERENCE_COUNT 4224)
(define CL_CONTEXT_DEVICES 4225)
(define CL_CONTEXT_PROPERTIES 4226)
(define CL_CONTEXT_NUM_DEVICES 4227)
(define CL_CONTEXT_PLATFORM 4228)
(define CL_CONTEXT_INTEROP_USER_SYNC 4229)
(define CL_DEVICE_PARTITION_EQUALLY 4230)
(define CL_DEVICE_PARTITION_BY_COUNTS 4231)
(define CL_DEVICE_PARTITION_BY_COUNTS_LIST_END 0)
(define CL_DEVICE_PARTITION_BY_AFFINITY_DOMAIN 4232)
(define CL_DEVICE_AFFINITY_DOMAIN_NUMA 1)
(define CL_DEVICE_AFFINITY_DOMAIN_L4_CACHE 2)
(define CL_DEVICE_AFFINITY_DOMAIN_L3_CACHE 4)
(define CL_DEVICE_AFFINITY_DOMAIN_L2_CACHE 8)
(define CL_DEVICE_AFFINITY_DOMAIN_L1_CACHE 16)
(define CL_DEVICE_AFFINITY_DOMAIN_NEXT_PARTITIONABLE 32)
(define CL_QUEUE_CONTEXT 4240)
(define CL_QUEUE_DEVICE 4241)
(define CL_QUEUE_REFERENCE_COUNT 4242)
(define CL_QUEUE_PROPERTIES 4243)
(define CL_MEM_READ_WRITE 1)
(define CL_MEM_WRITE_ONLY 2)
(define CL_MEM_READ_ONLY 4)
(define CL_MEM_USE_HOST_PTR 8)
(define CL_MEM_ALLOC_HOST_PTR 16)
(define CL_MEM_COPY_HOST_PTR 32)
(define CL_MEM_HOST_WRITE_ONLY 128)
(define CL_MEM_HOST_READ_ONLY 256)
(define CL_MEM_HOST_NO_ACCESS 512)
(define CL_MIGRATE_MEM_OBJECT_HOST 1)
(define CL_MIGRATE_MEM_OBJECT_CONTENT_UNDEFINED 2)
(define CL_R 4272)
(define CL_A 4273)
(define CL_RG 4274)
(define CL_RA 4275)
(define CL_RGB 4276)
(define CL_RGBA 4277)
(define CL_BGRA 4278)
(define CL_ARGB 4279)
(define CL_INTENSITY 4280)
(define CL_LUMINANCE 4281)
(define CL_Rx 4282)
(define CL_RGx 4283)
(define CL_RGBx 4284)
(define CL_DEPTH 4285)
(define CL_DEPTH_STENCIL 4286)
(define CL_SNORM_INT8 4304)
(define CL_SNORM_INT16 4305)
(define CL_UNORM_INT8 4306)
(define CL_UNORM_INT16 4307)
(define CL_UNORM_SHORT_565 4308)
(define CL_UNORM_SHORT_555 4309)
(define CL_UNORM_INT_101010 4310)
(define CL_SIGNED_INT8 4311)
(define CL_SIGNED_INT16 4312)
(define CL_SIGNED_INT32 4313)
(define CL_UNSIGNED_INT8 4314)
(define CL_UNSIGNED_INT16 4315)
(define CL_UNSIGNED_INT32 4316)
(define CL_HALF_FLOAT 4317)
(define CL_FLOAT 4318)
(define CL_UNORM_INT24 4319)
(define CL_MEM_OBJECT_BUFFER 4336)
(define CL_MEM_OBJECT_IMAGE2D 4337)
(define CL_MEM_OBJECT_IMAGE3D 4338)
(define CL_MEM_OBJECT_IMAGE2D_ARRAY 4339)
(define CL_MEM_OBJECT_IMAGE1D 4340)
(define CL_MEM_OBJECT_IMAGE1D_ARRAY 4341)
(define CL_MEM_OBJECT_IMAGE1D_BUFFER 4342)
(define CL_MEM_TYPE 4352)
(define CL_MEM_FLAGS 4353)
(define CL_MEM_SIZE 4354)
(define CL_MEM_HOST_PTR 4355)
(define CL_MEM_MAP_COUNT 4356)
(define CL_MEM_REFERENCE_COUNT 4357)
(define CL_MEM_CONTEXT 4358)
(define CL_MEM_ASSOCIATED_MEMOBJECT 4359)
(define CL_MEM_OFFSET 4360)
(define CL_IMAGE_FORMAT 4368)
(define CL_IMAGE_ELEMENT_SIZE 4369)
(define CL_IMAGE_ROW_PITCH 4370)
(define CL_IMAGE_SLICE_PITCH 4371)
(define CL_IMAGE_WIDTH 4372)
(define CL_IMAGE_HEIGHT 4373)
(define CL_IMAGE_DEPTH 4374)
(define CL_IMAGE_ARRAY_SIZE 4375)
(define CL_IMAGE_BUFFER 4376)
(define CL_IMAGE_NUM_MIP_LEVELS 4377)
(define CL_IMAGE_NUM_SAMPLES 4378)
(define CL_ADDRESS_NONE 4400)
(define CL_ADDRESS_CLAMP_TO_EDGE 4401)
(define CL_ADDRESS_CLAMP 4402)
(define CL_ADDRESS_REPEAT 4403)
(define CL_ADDRESS_MIRRORED_REPEAT 4404)
(define CL_FILTER_NEAREST 4416)
(define CL_FILTER_LINEAR 4417)
(define CL_SAMPLER_REFERENCE_COUNT 4432)
(define CL_SAMPLER_CONTEXT 4433)
(define CL_SAMPLER_NORMALIZED_COORDS 4434)
(define CL_SAMPLER_ADDRESSING_MODE 4435)
(define CL_SAMPLER_FILTER_MODE 4436)
(define CL_MAP_READ 1)
(define CL_MAP_WRITE 2)
(define CL_MAP_WRITE_INVALIDATE_REGION 4)
(define CL_PROGRAM_REFERENCE_COUNT 4448)
(define CL_PROGRAM_CONTEXT 4449)
(define CL_PROGRAM_NUM_DEVICES 4450)
(define CL_PROGRAM_DEVICES 4451)
(define CL_PROGRAM_SOURCE 4452)
(define CL_PROGRAM_BINARY_SIZES 4453)
(define CL_PROGRAM_BINARIES 4454)
(define CL_PROGRAM_NUM_KERNELS 4455)
(define CL_PROGRAM_KERNEL_NAMES 4456)
(define CL_PROGRAM_BUILD_STATUS 4481)
(define CL_PROGRAM_BUILD_OPTIONS 4482)
(define CL_PROGRAM_BUILD_LOG 4483)
(define CL_PROGRAM_BINARY_TYPE 4484)
(define CL_PROGRAM_BINARY_TYPE_NONE 0)
(define CL_PROGRAM_BINARY_TYPE_COMPILED_OBJECT 1)
(define CL_PROGRAM_BINARY_TYPE_LIBRARY 2)
(define CL_PROGRAM_BINARY_TYPE_EXECUTABLE 4)
(define CL_BUILD_SUCCESS 0)
(define CL_BUILD_NONE -1)
(define CL_BUILD_ERROR -2)
(define CL_BUILD_IN_PROGRESS -3)
(define CL_KERNEL_FUNCTION_NAME 4496)
(define CL_KERNEL_NUM_ARGS 4497)
(define CL_KERNEL_REFERENCE_COUNT 4498)
(define CL_KERNEL_CONTEXT 4499)
(define CL_KERNEL_PROGRAM 4500)
(define CL_KERNEL_ATTRIBUTES 4501)
(define CL_KERNEL_ARG_ADDRESS_QUALIFIER 4502)
(define CL_KERNEL_ARG_ACCESS_QUALIFIER 4503)
(define CL_KERNEL_ARG_TYPE_NAME 4504)
(define CL_KERNEL_ARG_TYPE_QUALIFIER 4505)
(define CL_KERNEL_ARG_NAME 4506)
(define CL_KERNEL_ARG_ADDRESS_GLOBAL 4507)
(define CL_KERNEL_ARG_ADDRESS_LOCAL 4508)
(define CL_KERNEL_ARG_ADDRESS_CONSTANT 4509)
(define CL_KERNEL_ARG_ADDRESS_PRIVATE 4510)
(define CL_KERNEL_ARG_ACCESS_READ_ONLY 4512)
(define CL_KERNEL_ARG_ACCESS_WRITE_ONLY 4513)
(define CL_KERNEL_ARG_ACCESS_READ_WRITE 4514)
(define CL_KERNEL_ARG_ACCESS_NONE 4515)
(define CL_KERNEL_ARG_TYPE_NONE 0)
(define CL_KERNEL_ARG_TYPE_CONST 1)
(define CL_KERNEL_ARG_TYPE_RESTRICT 2)
(define CL_KERNEL_ARG_TYPE_VOLATILE 4)
(define CL_KERNEL_WORK_GROUP_SIZE 4528)
(define CL_KERNEL_COMPILE_WORK_GROUP_SIZE 4529)
(define CL_KERNEL_LOCAL_MEM_SIZE 4530)
(define CL_KERNEL_PREFERRED_WORK_GROUP_SIZE_MULTIPLE 4531)
(define CL_KERNEL_PRIVATE_MEM_SIZE 4532)
(define CL_KERNEL_GLOBAL_WORK_SIZE 4533)
(define CL_EVENT_COMMAND_QUEUE 4560)
(define CL_EVENT_COMMAND_TYPE 4561)
(define CL_EVENT_REFERENCE_COUNT 4562)
(define CL_EVENT_COMMAND_EXECUTION_STATUS 4563)
(define CL_EVENT_CONTEXT 4564)
(define CL_COMMAND_NDRANGE_KERNEL 4592)
(define CL_COMMAND_TASK 4593)
(define CL_COMMAND_NATIVE_KERNEL 4594)
(define CL_COMMAND_READ_BUFFER 4595)
(define CL_COMMAND_WRITE_BUFFER 4596)
(define CL_COMMAND_COPY_BUFFER 4597)
(define CL_COMMAND_READ_IMAGE 4598)
(define CL_COMMAND_WRITE_IMAGE 4599)
(define CL_COMMAND_COPY_IMAGE 4600)
(define CL_COMMAND_COPY_IMAGE_TO_BUFFER 4601)
(define CL_COMMAND_COPY_BUFFER_TO_IMAGE 4602)
(define CL_COMMAND_MAP_BUFFER 4603)
(define CL_COMMAND_MAP_IMAGE 4604)
(define CL_COMMAND_UNMAP_MEM_OBJECT 4605)
(define CL_COMMAND_MARKER 4606)
(define CL_COMMAND_ACQUIRE_GL_OBJECTS 4607)
(define CL_COMMAND_RELEASE_GL_OBJECTS 4608)
(define CL_COMMAND_READ_BUFFER_RECT 4609)
(define CL_COMMAND_WRITE_BUFFER_RECT 4610)
(define CL_COMMAND_COPY_BUFFER_RECT 4611)
(define CL_COMMAND_USER 4612)
(define CL_COMMAND_BARRIER 4613)
(define CL_COMMAND_MIGRATE_MEM_OBJECTS 4614)
(define CL_COMMAND_FILL_BUFFER 4615)
(define CL_COMMAND_FILL_IMAGE 4616)
(define CL_COMPLETE 0)
(define CL_RUNNING 1)
(define CL_SUBMITTED 2)
(define CL_QUEUED 3)
(define CL_BUFFER_CREATE_TYPE_REGION 4640)
(define CL_PROFILING_COMMAND_QUEUED 4736)
(define CL_PROFILING_COMMAND_SUBMIT 4737)
(define CL_PROFILING_COMMAND_START 4738)
(define CL_PROFILING_COMMAND_END 4739)

(provide (all-defined-out))
